---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: tgui::BaseTheme Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacetgui.html">tgui</a></li><li class="navelem"><a class="el" href="classtgui_1_1BaseTheme.html">BaseTheme</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="classtgui_1_1BaseTheme-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">tgui::BaseTheme Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Base class for the <a class="el" href="classtgui_1_1Theme.html" title="Default Theme class. ">Theme</a> classes.  
 <a href="classtgui_1_1BaseTheme.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Theme_8hpp_source.html">Theme.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for tgui::BaseTheme:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classtgui_1_1BaseTheme.png" usemap="#tgui::BaseTheme_map" alt=""/>
  <map id="tgui::BaseTheme_map" name="tgui::BaseTheme_map">
<area href="classtgui_1_1Theme.html" title="Default Theme class. " alt="tgui::Theme" shape="rect" coords="0,112,265,136"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a4505ccf085cc621b14f91193897cb467"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4505ccf085cc621b14f91193897cb467"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a4505ccf085cc621b14f91193897cb467">~BaseTheme</a> ()=default</td></tr>
<tr class="memdesc:a4505ccf085cc621b14f91193897cb467"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor. <br /></td></tr>
<tr class="separator:a4505ccf085cc621b14f91193897cb467"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a6a0cd9615c073b143189a6a1a82a4e"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a8a6a0cd9615c073b143189a6a1a82a4e">widgetAttached</a> (<a class="el" href="classtgui_1_1Widget.html">Widget</a> *widget)</td></tr>
<tr class="memdesc:a8a6a0cd9615c073b143189a6a1a82a4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual function that gets called when a widget is connected to this theme.  <a href="#a8a6a0cd9615c073b143189a6a1a82a4e">More...</a><br /></td></tr>
<tr class="separator:a8a6a0cd9615c073b143189a6a1a82a4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb0553ae4e04d07db72923080e9be98d"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#abb0553ae4e04d07db72923080e9be98d">widgetDetached</a> (<a class="el" href="classtgui_1_1Widget.html">Widget</a> *widget)</td></tr>
<tr class="memdesc:abb0553ae4e04d07db72923080e9be98d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual function that gets called when a widget is disconnected from this theme.  <a href="#abb0553ae4e04d07db72923080e9be98d">More...</a><br /></td></tr>
<tr class="separator:abb0553ae4e04d07db72923080e9be98d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57595e4c45be4574b70d006fb2acf3b3"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a57595e4c45be4574b70d006fb2acf3b3">internalLoad</a> (const std::string &amp;primary, const std::string &amp;secondary)=0</td></tr>
<tr class="memdesc:a57595e4c45be4574b70d006fb2acf3b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function can be used inside a widget to load other widgets without access to the derived theme class.  <a href="#a57595e4c45be4574b70d006fb2acf3b3">More...</a><br /></td></tr>
<tr class="separator:a57595e4c45be4574b70d006fb2acf3b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33384e4f4f47b8110e7d487049a41405"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a33384e4f4f47b8110e7d487049a41405">initWidget</a> (<a class="el" href="classtgui_1_1Widget.html">Widget</a> *widget, std::string primary, std::string secondary)=0</td></tr>
<tr class="memdesc:a33384e4f4f47b8110e7d487049a41405"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual function called by the widget to finish its initialization.  <a href="#a33384e4f4f47b8110e7d487049a41405">More...</a><br /></td></tr>
<tr class="separator:a33384e4f4f47b8110e7d487049a41405"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a6df0b3356afa3ef601518dbf8b8c52f2"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a6df0b3356afa3ef601518dbf8b8c52f2">setConstructFunction</a> (const std::string &amp;type, const std::function&lt; <a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>()&gt; &amp;constructor)</td></tr>
<tr class="memdesc:a6df0b3356afa3ef601518dbf8b8c52f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Changes the construct function of a specific widget type.  <a href="#a6df0b3356afa3ef601518dbf8b8c52f2">More...</a><br /></td></tr>
<tr class="separator:a6df0b3356afa3ef601518dbf8b8c52f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7e67bae705f027d34833220bebbc520"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#af7e67bae705f027d34833220bebbc520">setThemeLoader</a> (const std::shared_ptr&lt; <a class="el" href="classtgui_1_1BaseThemeLoader.html">BaseThemeLoader</a> &gt; &amp;themeLoader)</td></tr>
<tr class="memdesc:af7e67bae705f027d34833220bebbc520"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change the function that will load the widget theme data.  <a href="#af7e67bae705f027d34833220bebbc520">More...</a><br /></td></tr>
<tr class="separator:af7e67bae705f027d34833220bebbc520"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr class="memitem:a11159db7392530214ecc982e9b0f55b8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a11159db7392530214ecc982e9b0f55b8"></a>
static std::map&lt; std::string, std::function&lt; <a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>()&gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a11159db7392530214ecc982e9b0f55b8">m_constructors</a></td></tr>
<tr class="memdesc:a11159db7392530214ecc982e9b0f55b8"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classtgui_1_1Widget.html" title="The parent class for every widget. ">Widget</a> creator functions. <br /></td></tr>
<tr class="separator:a11159db7392530214ecc982e9b0f55b8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d1445eda90da9bf03a9c433df10d6b6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5d1445eda90da9bf03a9c433df10d6b6"></a>
static std::shared_ptr&lt; <a class="el" href="classtgui_1_1BaseThemeLoader.html">BaseThemeLoader</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtgui_1_1BaseTheme.html#a5d1445eda90da9bf03a9c433df10d6b6">m_themeLoader</a></td></tr>
<tr class="memdesc:a5d1445eda90da9bf03a9c433df10d6b6"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classtgui_1_1Theme.html" title="Default Theme class. ">Theme</a> loading functions, they read the theme file. <br /></td></tr>
<tr class="separator:a5d1445eda90da9bf03a9c433df10d6b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Base class for the <a class="el" href="classtgui_1_1Theme.html" title="Default Theme class. ">Theme</a> classes. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a33384e4f4f47b8110e7d487049a41405"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void tgui::BaseTheme::initWidget </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classtgui_1_1Widget.html">Widget</a> *&#160;</td>
          <td class="paramname"><em>widget</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>primary</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>secondary</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Virtual function called by the widget to finish its initialization. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">widget</td><td>The widget that needs to be initialized </td></tr>
    <tr><td class="paramname">primary</td><td>Primary parameter of the loader </td></tr>
    <tr><td class="paramname">secondary</td><td>Secondary parameter of the loader </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classtgui_1_1Theme.html#a0799e83b9c999ce798c5e79c847ec990">tgui::Theme</a>.</p>

</div>
</div>
<a class="anchor" id="a57595e4c45be4574b70d006fb2acf3b3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classtgui_1_1WidgetConverter.html">WidgetConverter</a> tgui::BaseTheme::internalLoad </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>primary</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>secondary</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This function can be used inside a widget to load other widgets without access to the derived theme class. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">primary</td><td>Primary parameter of the loader </td></tr>
    <tr><td class="paramname">secondary</td><td>Secondary parameter of the loader </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classtgui_1_1Theme.html#af1d7c0bd769f542fdcbf133f7358ea93">tgui::Theme</a>.</p>

</div>
</div>
<a class="anchor" id="a6df0b3356afa3ef601518dbf8b8c52f2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void tgui::BaseTheme::setConstructFunction </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::function&lt; <a class="el" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a>()&gt; &amp;&#160;</td>
          <td class="paramname"><em>constructor</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Changes the construct function of a specific widget type. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">type</td><td>Type of the widget which will cause this construct function to be used </td></tr>
    <tr><td class="paramname">constructor</td><td>New function to be called when this type of widget is being loaded </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af7e67bae705f027d34833220bebbc520"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void tgui::BaseTheme::setThemeLoader </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classtgui_1_1BaseThemeLoader.html">BaseThemeLoader</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>themeLoader</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Change the function that will load the widget theme data. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">themeLoader</td><td>Pointer to the new loader </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8a6a0cd9615c073b143189a6a1a82a4e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void tgui::BaseTheme::widgetAttached </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classtgui_1_1Widget.html">Widget</a> *&#160;</td>
          <td class="paramname"><em>widget</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Virtual function that gets called when a widget is connected to this theme. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">widget</td><td>The widget that was attached to this theme </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abb0553ae4e04d07db72923080e9be98d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void tgui::BaseTheme::widgetDetached </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classtgui_1_1Widget.html">Widget</a> *&#160;</td>
          <td class="paramname"><em>widget</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Virtual function that gets called when a widget is disconnected from this theme. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">widget</td><td>The widget that was detached from this theme </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classtgui_1_1Theme.html#a002af61e6bf83f0bbe6b849bcb5f4224">tgui::Theme</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>include/TGUI/Loading/<a class="el" href="Theme_8hpp_source.html">Theme.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:41 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
